<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN"
          "http://www.w3.org/TR/REC-html40/loose.dtd">
<HTML>

<HEAD>
<TITLE>JFLA 2000</TITLE>
</HEAD>

<BODY BGCOLOR="#FFFFFF">

<H1 ALIGN=CENTER>JFLA 2000: relecture du papier 2</H1>

<P>Numero du papier: 2
<P>Titre du papier:   Un cadre pour la définition récursive des structures de données.
<P>Auteurs: Jean-Louis Giavitto et Olivier Michel

<P>Nom du rapporteur: Luc Maranget

<P>Confiance en la note: 2
<!-- 1 : je n'ai pas compris car ce n'est pas mon domaine.
     2 : j'ai compris, mais je ne domine pas le sujet.
     3 : j'ai tout compris car c'est mon domaine. -->

<P>Notation du papier: 3
<!-- 1 : a rejeter; 2 : ininteressant; 3 : acceptable;
     4 : bon papier; 5: tres bon papier -->

<P>Commentaires aux auteurs:<P>


<P>Comme l'indique son nom, l'article présente un cadre théorique plutôt
nouveau pour définir les structures de données.
Ce cadre permet d'identifier les vecteurs qui sont constructibles par
un programme strict travaillant de gauche à droite dans ce tableau.
(Je trahis un peu la sophistication de ces travaux par ce racourci).
Notons que des constructions similaires existent dans les langages
paresseux et qu'elles sont dans ce cadre utiles car autrement plus expressives.


<P>La dépense théorique est considérable pour un résultat à mon avis peu
significatif du point de vue de la conception d'une construction de
programmation.  Car, pour un sous-ensemble aussi limité que les
tableaux qui se calculent de gauche à droite, il n'est pas évident que
le programmeur n'exprimera pas plus facilement ses intentions en
écrivant quelques boucles, qu'une définition plus intentionnelle à
l'aide d'opérateurs quand même un peu exotiques. De même, en cas de
refus de compilation, il sera peut-être difficile pour le programmeur
de corriger son programme.

<P>Toutefois je trahis un peu l'esprit de l'article par ma présentation:
le papier fait preuve d'une certaine virtuosité (mais aussi
d'innattentions coupables, dans les présentations rigoureuses à base de
symboles) dans les manipulations sémantiques et d'un souci poussé de
la géneralisation, dont on peut penser qu'ils sont des aspects
valables.  La réflexion sur ce qu'est une structure de donnée est
approfondie.  J'avoue que ce n'est pas ma tasse de thé. De même, et
toujours à titre personnel, je suis géné par la cascade de définitions
concepts etc. pour un résultat « concret » (i.e. utilisable pour
étendre un langage tel que Caml) tout à fait limité.

<P>C'est pourquoi je recommande sans insister la publication de cet
article au titre de son apport à une reflexion sémantique sur les
structures de données.



<P>+++++++++++++++++++++++++++++++++++++++++++++++++++



<P>Page 2.

<P>La comparaison avec Haskell n'est pas tout à fait équilibrée.
<P>Voici la mienne :
<P>  Contexte : Dans tous les langages de programmation généraux, on
             peut écrire des programmes qui ne terminent pas.
             Cela ne signifie pas pour autant que ces langages sont
             inutilisables, bien au contraire.

<P>      - Les définitions récursives  de structures de données sont
        évaluables (au moins en parties) par un langage paresseux, dès
        que ces structures ne se réduisent pas a bottom.
<P>      - L'expressivité de ces définitions est donc considérable.
        Leur écriture est intuitive, après un temps d'adaptation.
<P>      - Il est possible de signaler à l'exécution une structure mal
        définie en arrêtant le programme (au lieu de  le laisser
        boucler) et c'est un plus pour la mise au point.

<P>Dans le cas de l'exemple 2:
<P>  let rec z = 1 :: tl z
<P>(Dont le plus petit point fixe est 1 :: _|_)
<P>L'expression ``hd z'' a du sens, Haskell saura la calculer....


<P>Ceci dit le cadre de l'étude est bien posé par les premières pages,
mais j'aurais apprécié plus d'explications sur l'évaluation
paresseuse et sur pourquoi votre cadre est l'évaluation  stricte.

<P>Page 4,
<P>(Note 1) Pascal avait des types tableaux avec taille dedans.
<P>Si on y a renoncé, il doit y avoir une raison. Pour y retourner, il
<P>faut sans doute une raison au moins aussi forte.

<P>Page 6.
<P>Je n'ai pas trouvé la définition de \phi (\phi_p ?)

<P>Qu'est ce que \OXS ?

<P>Qu'est-ce que Def ?

<P>Page 7.
<P>Pourquoi deux notations pour f_O = J_{O -> \bot} ?
<P>Ce genre de choix ne facilite pas la lecture !

<P>Le paragraphe 2.5 est mal rédigé.

<P>Il commence par une contradiction flagrante :
<P>  Un élément O de \O ne correspond généralement pas à un type [...].
 C'est l'ensemble \O qui correspond à un type CAML. Nous allons
  cependant considérer les \O (!) comme des types [...]
    (ça doit être O, je pense)
    Si l'auteur se perd dans ses notations, que penser du lecteur...

<P>  Les mots ``théoriquement résolu'' sont mal-venus, surtout quand
  l'explication
         ``il suffit de résoudre
           l'équation sur $fix \tilde{P}$ plûtot que sur \top_{\O}'' 
   est aussi cryptique.

<P>  On doit pouvoir expliquer cela plus clairement, l'essentiel étant
  le caractère fini d'un ensemble (de positions ??) d'où sans doute
  les types tableaux de taille fixée. Tout cela me semble exagérément
  compliqué.




<P>Page 7, 8.

<P>Je craque sur la définition du préfixe qui est plutôt abstraite.

<P>La définition 4 atteint un sommet d'abstraction, les exemples donnés
3 pages plus loin permettent saisir l'idée.

<P>Je préfère les exemples d'abord...



<P>Page 9.
<P>(Sur eoshift) Tous les lecteurs de ce type d'article ne connaissent
pas Fortran ! (mais j'apprécie l'humour).

<P>Page 10.

<P>Il y a un mélange sans gravité.
entre le cadre restreint de l'article (un programme = une équation) et
le cadre plus géneral (un programme = plusieures équations).



<P>Commentaires reserves au comite de programme:<P>

</BODY>
</HTML>

